/****************************************/
/* Cool Herders                         */
/* A demented muse by Brendan Wiese     */
/* http://starbow.org                   */
/* Programmed by Mike Brent             */
/* http://tursi.yiffco.com              */
/* bmp.h                                */
/****************************************/

/* Bitmap stuff */
#define BI_RGB          0
#define BI_RLE8         1
#define BI_RLE4         2
#define BI_BITFIELDS    3

#define BLOCKSIZE 131072		// 256x256x16bit

#define WININFOHEADERSIZE  40

typedef struct BITMAP
{
	unsigned long	nWidth;
	unsigned long	nHeight;
	unsigned long	adjustedWidth;
	unsigned long	adjustedHeight;
	unsigned int	nXBlocks;
	unsigned int	nYBlocks;

	unsigned short	data[1];			// Data starts here. the '1' is cause GCC hates []
} BITMAP;

typedef struct BITMAPFILEHEADER
{
	unsigned short bfType;
	unsigned long  bfSize;
	unsigned short bfReserved1;
	unsigned short bfReserved2;
	unsigned long  bfOffBits;
} BITMAPFILEHEADER;

typedef struct BITMAPINFOHEADER
{
	unsigned long  biWidth;
	unsigned long  biHeight;
	unsigned short biBitCount;
	unsigned long  biCompression;

	unsigned long  adjustedWidth;
	unsigned long  adjustedHeight;
	unsigned int   nXBlocks;
	unsigned int   nYBlocks;
} BITMAPINFOHEADER;

typedef struct WINBMPINFOHEADER  /* size: 40 */
{
	unsigned long  biWidth;
	unsigned long  biHeight;
	unsigned short biPlanes;
	unsigned short biBitCount;
	unsigned long  biCompression;
	unsigned long  biSizeImage;
	unsigned long  biXPelsPerMeter;
	unsigned long  biYPelsPerMeter;
	unsigned long  biClrUsed;
	unsigned long  biClrImportant;
} WINBMPINFOHEADER;

BITMAP *load_bmp(char *filename);
